import { Message } from "discord.js-light";
import { CommandObj } from "../types";
export default class {
    private _name;
    private _invokes;
    private _description;
    private _usage;
    private _execute;
    private _category;
    private _permissions;
    private _omitHelp;
    constructor();
    set name(value: string);
    set description(value: string);
    set invokes(value: string[]);
    set usage(value: string);
    set permissions(value: string[]);
    set category(value: string);
    set execute(value: (message?: Message | object, options?: any) => Promise<void>);
    set omitHelp(value: boolean);
    get command(): CommandObj;
}
