"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class default_1 {
    constructor() {
        this._name = "no-name";
        this._invokes = [];
        this._description = "No Name Command";
        this._usage = "";
        this._execute = (message = {}, options = null) => __awaiter(this, void 0, void 0, function* () {
            return;
        });
        this._category = "";
        this._permissions = [];
        this._omitHelp = false;
    }
    // Setters
    set name(value) {
        this._name = value;
    }
    set description(value) {
        this._description = value;
    }
    set invokes(value) {
        this._invokes = value;
    }
    set usage(value) {
        this._usage = value;
    }
    set permissions(value) {
        this._permissions = value;
    }
    set category(value) {
        this._category = value;
    }
    set execute(value) {
        this._execute = value;
    }
    set omitHelp(value) {
        this._omitHelp = value;
    }
    get command() {
        const commandObj = {
            category: this._category,
            description: this._description,
            execute: this._execute,
            invoke: this._invokes,
            name: this._name,
            usage: this._usage,
            permissions: this._permissions,
            omitHelp: this._omitHelp,
        };
        return commandObj;
    }
}
exports.default = default_1;
